#define DBGL 0  // debug msg level

#define RES_EXP 1   // result type experiment
#define RES_CAL 2   // result type calculated

#define C_NAME_LEN 6    // length of component name, including \0

#define MAX_LINE_LENGTH 1024
#define FILE_EXPDATA "experiment.dat"

#define VAL_UNKNOWN -9999
#define VAL_UNKNOWN_STR "NA"

#define DYNAMIC_MEM_ALLOC 1


typedef struct {
    int id, type, exp, flag_ph_ab;  // unique ID; type (meas/callc); experiment num; flag phase abundance
                                    //                                               (1=abundance; 2=exst/non-exst)
    double P, T;
    double *bulkcomp;
    double *phasewt;
    double *phasecomp;
    int *phasepresent;
} Result;

typedef struct {
    int count;
    Result *result;
} Experiments;

typedef struct {
    int count;
    Experiments *experiments;
} ExpVariations;

void initialize();
int getPhaseNumberPtr();
int getPhaseNumber();
Result pToResult();
void safefree();
int readNumArray();
int irregArrPos();

